package org.simantics.scl.runtime.xml;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.nio.charset.Charset;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

public class XMLUtils {

    public static Document parseXML(String content) throws ParserConfigurationException, SAXException, IOException {
        DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
        DocumentBuilder newDocumentBuilder = documentBuilderFactory.newDocumentBuilder();
        Document document = newDocumentBuilder.parse(new ByteArrayInputStream(content.getBytes(Charset.forName("UTF-8"))));
        return document;
    }
    
    public static Element asElement(Node node) {
        if(node instanceof Element)
            return (Element)node;
        else
            return null;
    }
    
    public static Document asDocument(Node node) {
        if(node instanceof Document)
            return (Document)node;
        else
            return null;
    }
    
}
